freeslot("MT_INVELNERABLEPEELOUT", "S_INVELNERABLEPEELOUT", "S_INVELNERABLEPEELOUT1", "S_INVELNERABLEPEELOUT2", "S_INVELNERABLEPEELOUT3", "SPR_IEPO")

states[S_INVELNERABLEPEELOUT] = {SPR_IEPO, A|FF_ANIMATE|FF_FULLBRIGHT, 1, nil, 1, 1, S_INVELNERABLEPEELOUT1}
states[S_INVELNERABLEPEELOUT1] = {SPR_IEPO, B|FF_ANIMATE|FF_FULLBRIGHT, 1, nil, 1, 1, S_INVELNERABLEPEELOUT2}
states[S_INVELNERABLEPEELOUT2] = {SPR_IEPO, C|FF_ANIMATE|FF_FULLBRIGHT, 1, nil, 1, 1, S_INVELNERABLEPEELOUT3}
states[S_INVELNERABLEPEELOUT3] = {SPR_IEPO, D|FF_ANIMATE|FF_FULLBRIGHT, 1, nil, 1, 1, S_NULL}

mobjinfo[MT_INVELNERABLEPEELOUT] = {
	doomednum = -1,
	spawnstate = S_INVELNERABLEPEELOUT,
	flags = MF_NOCLIP|MF_SCENERY|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

local function SparksInvelnerablePeelout(player)
	local ipeelout = P_SpawnMobjFromMobj(player.mo, P_RandomRange(-10, 10)*FRACUNIT, P_RandomRange(-10, 10)*FRACUNIT, 20*FRACUNIT, MT_INVELNERABLEPEELOUT) 
	ipeelout.momx = P_RandomRange(-9, 9)*FRACUNIT
	ipeelout.momy = P_RandomRange(-9, 9)*FRACUNIT
	ipeelout.momz = P_RandomRange(-9, 9)*FRACUNIT
	ipeelout.spritexscale = $*3/2
	ipeelout.spriteyscale = $*3/2
end

local SKIN = "sonic" -- Here you can change the character's skin name.
local invelnerablepeeloutincluded = false -- Local for proper operation, it should not be touched.
local BUTTONPEELOUT = BT_CUSTOM1 -- Super peel-out charging button.

// Super peel-out from Triple Trouble.
addHook("PlayerThink", function(player)
	if player.mo.skin == SKIN and not (player.powers[pw_super] or player.powers[pw_invulnerability]) and player.tripletroublepeelout == true
		if player.mo.invelnerablepeelout == nil
			player.mo.invelnerablepeelout = 0
		end
		if (player.cmd.buttons & BUTTONPEELOUT and player.mo.peelsound == 1)
			SparksInvelnerablePeelout(player)
			invelnerablepeeloutincluded = true
		end
		if (player.mo.peelout == 1 or player.mo.peelout == 2) and invelnerablepeeloutincluded == true
			player.mo.invelnerablepeelout = $1 + 1
			if player.mo.invelnerablepeelout < 40
				SparksInvelnerablePeelout(player)
			end
			if player.mo.invelnerablepeelout >= 39 or player.mo.state == S_PLAY_ROLL or player.mo.state == S_PLAY_JUMP
				player.mo.invelnerablepeelout = 0
				invelnerablepeeloutincluded = false
			end
		elseif player.mo.peelout == 0
			player.mo.invelnerablepeelout = 0
		end
	end
end)

// Super peel-out from Chaos.
addHook("PlayerThink", function(player)
	if player.mo.skin == SKIN and not (player.powers[pw_super] or player.powers[pw_invulnerability]) and player.chaospeelout == true
	if player.mo.invelnerablepeelout == nil
			player.mo.invelnerablepeelout = 0
		end
		if (player.cmd.buttons & BUTTONPEELOUT and player.mo.peelsound == 1)
			if player.mo.peelouttimer < 70
				invelnerablepeeloutincluded = false
			elseif player.mo.peelouttimer >= 70
				SparksInvelnerablePeelout(player)
				invelnerablepeeloutincluded = true
			end
			end
		 if player.mo.peelsound == 1 and not (player.cmd.buttons & BUTTONPEELOUT or invelnerablepeeloutincluded == true)
				player.powers[pw_flashing] = 30
				elseif ((player.speed <= 45*FRACUNIT and player.mo.peelout == 1) or (player.speed <= 36*FRACUNIT and player.mo.peelout == 2))
        or ((player.mo.peelout == 1 or player.mo.peelout == 2) and (player.mo.state == S_PLAY_ROLL or player.mo.state == S_PLAY_JUMP))
    player.powers[pw_flashing] = 0
end
		if (player.mo.peelout == 1 or player.mo.peelout == 2) and invelnerablepeeloutincluded == true
			player.mo.invelnerablepeelout = $1 + 1
			if player.mo.invelnerablepeelout < 40
				SparksInvelnerablePeelout(player)
			end
			if player.mo.invelnerablepeelout >= 39 or player.mo.state == S_PLAY_ROLL or player.mo.state == S_PLAY_JUMP
				player.mo.invelnerablepeelout = 0
				invelnerablepeeloutincluded = false
			end
		elseif player.mo.peelout == 0
			player.mo.invelnerablepeelout = 0
		end
	end
end)

// Damage during the effect.
addHook("PlayerCanDamage", function(player)
	if player.mo.skin == SKIN and (player.mo.peelout == 1 or player.mo.peelout == 2) and invelnerablepeeloutincluded == true 
	and (player.chaospeelout == true or player.tripletroublepeelout == true)
		if player.mo.state == S_PLAY_DASH
			return true
		end
	end
end)